#include <windows.h>
#include <mmsystem.h>

LRESULT APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT PerformMenuCommand(HWND hWnd, WPARAM wParam);

#define BTN_EXIT	40100
#define TMR_TIMER	40101

#define Secondz		60 * 60 // 2 * 60

HWND hWnd;
HWND hExit;

int STDCALL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {

	HINSTANCE hInst;
	WNDCLASS wndClass;
	MSG msg;

	UINT hTimer;

	hInst = GetModuleHandle(NULL);

	wndClass.style = CS_HREDRAW | CS_VREDRAW;
	wndClass.lpfnWndProc = WndProc;
	wndClass.cbClsExtra = (int)NULL;
	wndClass.cbWndExtra = (int)NULL;
	wndClass.hInstance = hInst;
	wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = (struct HBRUSH__ *)GetStockObject(LTGRAY_BRUSH);
	wndClass.lpszMenuName = NULL;
	wndClass.lpszClassName = "CDJokeClass";
	RegisterClass(&wndClass);

	hWnd = CreateWindowEx(WS_EX_TOOLWINDOW,"CDJokeClass","CD Joke Copyright  2002 Cyrill Tkachenko",WS_OVERLAPPEDWINDOW,0,0,60,50,NULL,NULL,hInst,NULL);
	hExit = CreateWindowEx(WS_EX_CLIENTEDGE,"BUTTON","EXIT",WS_CHILD|WS_VISIBLE,0,0,50,25,hWnd,(struct HMENU__ *)BTN_EXIT,hInst,NULL);

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);

	hTimer = SetTimer(hWnd,TMR_TIMER,Secondz * 1000,NULL);

	while (GetMessage(&msg, NULL, (int)NULL, (int)NULL)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		};

	return 0;

}

LRESULT APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	switch(message) {

	case WM_COMMAND:
		return PerformMenuCommand(hWnd, wParam);

	case WM_DESTROY:
		KillTimer(hWnd,TMR_TIMER);
		PostQuitMessage(0);
		return 0;

	case WM_TIMER:
		mciSendString("Set CDAudio Door Open Wait",0,0,0);
		mciSendString("Set CDAudio Door Closed Wait",0,0,0);
		return 0;
	};

	return DefWindowProc(hWnd, message, wParam, lParam);
}

LRESULT PerformMenuCommand(HWND hWnd, WPARAM wParam) {

	switch(LOWORD(wParam)) {

	case BTN_EXIT:
		KillTimer(hWnd,TMR_TIMER);
		PostQuitMessage(0);
		return 0;

	};

	return 0;
}
