#include <windows.h>
#include <shellapi.h>
#include "resource.h"

LRESULT APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT PerformMenuCommand(HWND hWnd, WPARAM wParam);

void FileSave(void);
void FileSaveAs(void);
void FileNew(void);
void FileOpen(void);

void WriteINF(void);
void ReadINF(void);

void SetFileName(void);

HWND hWnd;
HWND hEdit;
HINSTANCE hInst;

char	FileName[MAX_PATH+1];
char	TempFileName[MAX_PATH+1];
BYTE	Buf[100000];

const char strINFEditor[] = "INF Editor";
const char strCopyright[] = "INF Editor\nCopyright  2002 Cyrill Tkachenko";

char strWantSave[256];
char strSureQuit[256];
char strCantUndo[256];
char strNONAME[256];

#include "inftempl.c"
#include "templs.c"

int STDCALL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {

	WNDCLASS wndClass;
	MSG msg;

	hInst = GetModuleHandle(NULL);

	wndClass.style = CS_HREDRAW | CS_VREDRAW;
	wndClass.lpfnWndProc = WndProc;
	wndClass.cbClsExtra = (int)NULL;
	wndClass.cbWndExtra = (int)NULL;
	wndClass.hInstance = hInst;
	wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.hCursor = NULL;
	wndClass.hbrBackground = (struct HBRUSH__ *)GetStockObject(LTGRAY_BRUSH);
	wndClass.lpszMenuName = MAKEINTRESOURCE(MENU1);
	wndClass.lpszClassName = "INFEditorClass";
	RegisterClass(&wndClass);

	hWnd = CreateWindow("INFEditorClass",strINFEditor,
		WS_OVERLAPPEDWINDOW,
		0,0,600,500,NULL,NULL,hInst,NULL);

	hEdit = CreateWindowEx(0,"EDIT","",
		WS_VISIBLE|WS_CHILD|ES_MULTILINE|WS_VSCROLL|WS_HSCROLL|WS_TABSTOP|ES_LEFT|ES_AUTOVSCROLL|ES_WANTRETURN,
		0,0,0,0,hWnd,0,hInst,0);

	SendMessage(hEdit, WM_SETFONT, (WPARAM)CreateFont(
		0,0,0,0,FW_THIN,FALSE,FALSE,FALSE,0,0,0,DEFAULT_QUALITY,
		FIXED_PITCH,0), 0);

	LoadString(hInst,ID_SUREQUIT,(char *)strSureQuit,256);
	LoadString(hInst,ID_WANTSAVE,(char *)strWantSave,256);
	LoadString(hInst,ID_CANTUNDO,(char *)strCantUndo,256);
	LoadString(hInst,ID_NONAME,(char *)strNONAME,256);

	ZeroMemory(&FileName, sizeof(FileName));
	ZeroMemory(&Buf,sizeof(Buf));

	SetFileName();

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, (int)NULL, (int)NULL)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		};

	return 0;

}

LRESULT APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	switch(message) {

	case WM_COMMAND:
		return PerformMenuCommand(hWnd, wParam);

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;

	case WM_SIZE:
		MoveWindow(hEdit,0,0,LOWORD(lParam),HIWORD(lParam),TRUE);
		return 0;
	};

	return DefWindowProc(hWnd, message, wParam, lParam);
}

LRESULT PerformMenuCommand(HWND hWnd, WPARAM wParam) {

	switch(LOWORD(wParam)) {

	case ID_FILE_EXIT:
		if (MessageBox(hWnd,strSureQuit,strINFEditor,MB_YESNO|MB_ICONERROR)==IDYES) {
			if (SendMessage(hEdit,EM_GETMODIFY,0,0)) {
				if (MessageBox(hWnd,strWantSave,strINFEditor,MB_YESNO|MB_ICONERROR)==IDYES) FileSaveAs(); };
			PostQuitMessage(0); };
		break;

	case ID_FILE_OPEN:
		FileOpen();
		break;

	case ID_FILE_NEW:
		FileNew();
		break;

	case ID_FILE_SAVE:
		FileSave();
		break;

	case ID_FILE_SAVEAS:
		FileSaveAs();
		break;

	case ID_EDIT_CUT:
		SendMessage(hEdit,WM_CUT,0,0);
		break;

	case ID_EDIT_COPY:
		SendMessage(hEdit,WM_COPY,0,0);
		break;

	case ID_EDIT_PASTE:
		SendMessage(hEdit,WM_PASTE,0,0);
		break;

	case ID_EDIT_SELECTALL:
		SendMessage(hEdit,EM_SETSEL,0,-1);
		break;

	case ID_EDIT_UNDO:
		if (SendMessage(hEdit,EM_CANUNDO,0,0))
			SendMessage(hEdit,WM_UNDO,0,0);
		else
			MessageBox(hEdit,strCantUndo,strINFEditor,MB_OK|MB_ICONWARNING);
		break;

	case ID_HELP_ABOUT:
		MessageBox(hEdit,strCopyright,strINFEditor,MB_OK);
		break;

	case ID_HELP_HELP:
		ShellExecute(hWnd,"OPEN","README.TXT",0,0,SW_NORMAL);
		break;

	case ID_INFEDIT_PASTETEMPLATE:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INFTempl);
		break;

//////////////////////////////////////////////////////////////////////////

	case ID_INFEDIT_HKCR:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_HKCR);
		break;

	case ID_INFEDIT_HKCU:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_HKCU);
		break;

	case ID_INFEDIT_HKLM:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_HKLM);
		break;

	case ID_INFEDIT_HKLMR:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_HKLMR);
		break;

	case ID_INFEDIT_HKLMRO:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_HKLMRO);
		break;

	case ID_INFEDIT_HKCUR:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_HKCUR);
		break;

	case ID_INFEDIT_LINKCR:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_LINKCR);
		break;

	case ID_INFEDIT_LINKDEL:
		SendMessage(hEdit,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)INF_LINKDEL);
		break;

//////////////////////////////////////////////////////////////////////////

	};

	return 0;

}

void FileNew(void) {

	OPENFILENAME ofna;
	ZeroMemory(&ofna, sizeof(OPENFILENAME));

//	ZeroMemory(&FileName, sizeof(FileName));
	ZeroMemory(&TempFileName, sizeof(TempFileName));

	ofna.lStructSize = sizeof(ofna);
	ofna.lpstrFilter = "*.INF";
	ofna.lpstrFile = (char *)TempFileName;
	ofna.Flags = OFN_OVERWRITEPROMPT;
	ofna.nMaxFile = sizeof(TempFileName);

	if(GetOpenFileName(&ofna)) {
		lstrcpy(FileName,TempFileName);
		SetFileName();
		ZeroMemory(&Buf,sizeof(Buf));
		SendMessage(hEdit,WM_SETTEXT,(WPARAM)sizeof(Buf),(LPARAM)Buf);
	};

}

void FileOpen(void) {

	OPENFILENAME ofna;
	ZeroMemory(&ofna, sizeof(OPENFILENAME));

//	ZeroMemory(&FileName, sizeof(FileName));

	ofna.lStructSize = sizeof(ofna);
	ofna.lpstrFilter = "*.INF";
	ofna.lpstrFile = (char *)FileName;
	ofna.Flags = (int)NULL;
	ofna.nMaxFile = sizeof(FileName);

	if(GetOpenFileName(&ofna)) {
		ReadINF();
		SetFileName();
	};

}

void FileSave(void) {

	OPENFILENAME ofna;
	ZeroMemory(&ofna, sizeof(OPENFILENAME));

	if (FileName[0]==(char)NULL) {
		ofna.lStructSize = sizeof(ofna);
		ofna.lpstrFilter = "*.INF";
		ofna.lpstrFile = (char *)FileName;
		ofna.nMaxFile = sizeof(FileName);
		GetSaveFileName(&ofna);

		WriteINF();
	};

}

void FileSaveAs(void) {

	OPENFILENAME ofna;
	ZeroMemory(&ofna, sizeof(OPENFILENAME));

	ZeroMemory(&FileName, sizeof(TempFileName));

	ofna.lStructSize = sizeof(ofna);
	ofna.lpstrFilter = "*.INF";
	ofna.Flags = OFN_OVERWRITEPROMPT;
	ofna.lpstrFile = (char *)TempFileName;
	ofna.nMaxFile = sizeof(TempFileName);

	if(GetSaveFileName(&ofna)) {
		lstrcpy(FileName,TempFileName);
		WriteINF();
		SetFileName();
	};

}

void WriteINF(void) {
	OFSTRUCT ReOpenBuf;
	if (FileName[0]==(char)NULL) return;
	HFILE hFile = OpenFile((const char *)FileName,&ReOpenBuf,OF_CREATE|OF_WRITE);
	LONG TextLength = SendMessage(hEdit,WM_GETTEXTLENGTH,0,0);
	SendMessage(hEdit,WM_GETTEXT,(WPARAM)TextLength,(LPARAM)Buf);
	if (Buf[TextLength-1]==0) Buf[TextLength-1]=10;
	_hwrite(hFile,(const char *)Buf,TextLength);
	_lclose(hFile);

}

void ReadINF(void) {
	OFSTRUCT ReOpenBuf;
	if (FileName[0]==(char)NULL) return;
	HFILE hFile = OpenFile((const char *)FileName,&ReOpenBuf,OF_READ);
	ZeroMemory(&Buf,sizeof(Buf));
	_hread(hFile,Buf,sizeof(Buf));
	_lclose(hFile);
	SendMessage(hEdit,WM_SETTEXT,0,(LPARAM)&Buf);
}

void SetFileName(void) {
	char Sended[MAX_PATH+200];
	if (FileName[0] != 0) wsprintf(Sended,"%s - %s",FileName,strINFEditor);
	else wsprintf(Sended,strNONAME,strINFEditor);
	SetWindowText(hWnd,Sended);
}
